/*
 * this is to be included by all kernel files if __KERNEL__ undefined
 */
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <asm/bitops.h>
#include <asm/types.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <malloc.h>
#include <linux/fs.h>
#define kdev_t dev_t

#include "io.h"
#include "inode.h"
#include "sb.h"
#include "reiserfs_fs_sb.h"
#include "reiserfs_fs.h"

/*#include "../include/io.h"
#include "../include/inode.h"
#include "../include/sb.h"
#include "../kernel-include/reiserfs_fs_sb.h"
#include "../kernel-include/reiserfs_fs.h"*/

#define printk printf
#define le16_to_cpu(x) ((__u16)x)
#define cpu_to_le16(x) ((__u16)x)
#define le32_to_cpu(x) ((__u32)x)
#define cpu_to_le32(x) ((__u32)x)
#define copy_from_user memcpy
#define copy_to_user memcpy
#define put_user(b,a) ((*(a))=b)
#define GFP_KERNEL 0
#define kmalloc(a,b) malloc(a)
#define kfree free
#define update_vm_cache(a,b,c,d)
#define wait_on_buffer __wait_on_buffer
#define NODEV 0
#define atomic_inc(a)
extern struct inode_operations chrdev_inode_operations;
extern struct inode_operations blkdev_inode_operations;

#define page_address(page) 0
void init_fifo(struct inode * inode);
#define buffer_req(bh) 0
#define kdevname(a) "kdevname"
#define kdev_t_to_nr(a) a
#define to_kdev_t(a) a
#define clear_inode(a)
#define PAGE_SIZE 4096
#define d_add(a,b) a->d_inode = b
#define d_instantiate(a,b) a->d_inode = b
#define d_delete(a)
#define down(a)
#define up(a)
#define MOD_DEC_USE_COUNT
#define MOD_INC_USE_COUNT
#define lock_super(a)
#define unlock_super(a)
#define set_blocksize(a,b)
#define d_alloc_root(a,b) 0
#define file_fsync 0

#define reiserfs_bread(a,b,c,d) bread(a,b,c)
#define reiserfs_getblk(a,b,c,d)  getblk(a,b,c)
extern struct inode_operations reiserfs_dir_inode_operations;
extern struct inode_operations reiserfs_symlink_inode_operations;
